<?php
include('config.inc.php');
include($_OWIKI['POWL'].'/include.php');
if($_OWIKI['powlURIBase'])
	$_POWL['uriBase']=$_OWIKI['powlURIBase'];

if ($_OWIKI['model'] && $powl->modelExists($_OWIKI['model'])) {
	$model = $powl->getModel($_OWIKI['model']);
	$_SESSION['_ETS']['model'] = $_OWIKI['model'];
} else
	$model = $_ET['rdfsmodel'];

/**
  * OntoWiki class
  *
  * @author Soeren Auer, Norman Heino
  * @version x, 2006-10-22
  */
class ontowiki {

	/**
	  * Returns a title string.
	  *
	  * @param $node
	  * @param $includeComment
	  * @param $maxWordLength
	  * @return
	  */
	function getTitle($node, $includeComment = true, $maxWordLength = 0) {

		$args = func_get_args();
		$c = new stmCache('ontowiki::getTitle', $args, $GLOBALS['model']);
		if ($c->value)
			return $c->value;

		if (is_a($node, 'literal'))
			return $maxWordLength ? ontowiki::shorten($node->getLabel(), $maxWordLength) : $node->getLabel();
		else if (is_a($node, 'blanknode'))
			return;
		else if(!is_a($node, 'resource'))
			return;

		if ($includeComment) {
			$comment = $node->getComment($_SESSION['PWL']['language']) ?
					$node->getComment($_SESSION['ONTOWIKI']['modelLanguage']) :
					$node->getComment('en');

			$comment = $comment ? $comment : $node->getComment();
			$comment = $comment ? $comment->getLabel() : '';

			if (strlen($comment) > 200)
				$comment = substr($comment,0,200).' ...';
		}

		foreach ($GLOBALS['_OWIKI']['titleProperties'] as $title) {
			if ($ret = $node->getLiteralPropertyValue($title, $_SESSION['ONTOWIKI']['modelLanguage']))
				$label = $ret->getLabel();
			else if($ret = $node->getPropertyValue($title))
				$label = $ret->getLabel();
			if ($label)
				break;
		}

		if (!$label)
			$label = $node->getLocalName();
		if ($maxWordLength /*&& strpos($label,' ')*/ && strlen($label) > $maxWordLength)
			$label = ontowiki::shorten($label, $maxWordLength);

		$ret = $comment ? '<span title="'.htmlentities($comment).'" class="help">'.$label.'</span>' : $label;
		$c->set($ret, $node);
		return $ret;
	}

	/**
	  * Displays objects.
	  *
	  * @param $s
	  * @param $allowEdit
	  * @param $maxValueLength
	  * @return
	  */
	function displayObject($s, $allowEdit = true, $maxValueLength = 0) {
		$ret = '<span id="stmId'.$s->dbId.'">';
		if (is_a($s->obj,'resource'))
			$ret = '<img src="'.$GLOBALS['_POWL']['uriBase'].'/images/plus.gif"
				title="Expand" onclick="ow.expand(this,\''.$s->obj->getLocalName().'\')"
				style="padding-right:5px" /><a href="'.ontowiki::getURL($s->obj).'">'.ontowiki::getTitle($s->obj).'
				</a><span></span>';

		else if (is_a($s->obj, 'literal')) {
			if (in_array($s->pred->getLocalName(), $GLOBALS['_OWIKI']['imgLinkProperties']) ||
					preg_match('/(\.(jpg|gif|jpeg|png)$)/i', $s->obj->getLabel()))
				$ret .= '<img src="'.$s->obj->getLabel().'" name="contentIMG" />';

			else if (in_array($s->pred->getLocalName(),
					$GLOBALS['_OWIKI']['webLinkProperties']) || strpos($s->obj->getLabel(), 'http://') === 0)
				$ret .= '<a href="'.$s->obj->getLabel().'">'.$s->obj->getLabel().'</a>';
			else {
				if ($maxValueLength)
					$ret .= nl2br(ontowiki::shorten(strip_tags($s->obj->getLabel()), 100));
				else
					$ret .= strstr($s->obj->getLabel(), '<') ? $s->obj->getLabel() : nl2br($s->obj->getLabel());
			}
		}

		if ($allowEdit) {
			$ret .= '&nbsp;<a href="javascript:
					if(confirm(\'Really delete?\')) ow.deleteStatement('.$s->dbId.');"
					class="edit" name="edit" style="display:none;">
				<img src="'.$GLOBALS['_POWL']['uriBase'].'/images/delete.gif" /></a>';
		}

		// $ret .= '<a title="Edit" href="javascript:powl.winopen(\''.
		// 	$GLOBALS['_POWL']['uriBase'].
		// 	'modules/rdf/node.php?model='.
		// 	urlencode(urlencode($GLOBALS['model']->modelURI)).
		// 	'&subj='.
		// 	urlencode(urlencode($s->subj->getLabel())).
		// 	'&pred='.
		// 	urlencode(urlencode($s->pred->getLabel())).
		// 	'&obj[value]='.
		// 	urlencode(urlencode($s->obj->getLabel())).
		// 	(is_a($s->obj,'literal') ? '&obj[type]=literal&obj[lang]='.
		// 	urlencode(urlencode($s->obj->getLanguage())).
		// 	'&obj[dtype]='.
		// 	urlencode(urlencode($s->obj->getDatatype())) : '').
		// 	'\',\'comment_edit\',\'width=350,height=400\');" class="edit"
		// 			name="edit" style="display:none;"><img src="'.
		// 	$GLOBALS['_POWL']['uriBase'].
		// 	'/images/edit.gif" /></a>';

		if ($r=$s->subj->model->findStatement('reified://'.$s->dbId, 'rdfs:comment', NULL)) {
			$ret .= '&nbsp;<a href="discussion.php?model='.
				urlencode($s->subj->model->modelURI).
				'&instance='.
				urlencode($s->subj->getLocalName()).
				'&predicate='.
				urlencode($s->pred->getLocalName()).
				'" title="'.
				$r->obj->getLabel().
				'"><img src="images/comment.png" /></a>';
		}

		$ret .= '&nbsp;<a name="comment" class="comment" style="display:none;" href="javascript:powl.winopen(\''.
			urlencode(ontowiki::nodeEditLink('reified://'.
			$s->dbId,'rdfs:comment')).
			'\',\'comment_edit\',\'width=350,height=400\');"
					title="Add comment"><img src="images/comment-add.png" /></a></span>';

		$ret .= '</span>';

		return $ret;
	}

	/**
	  *
	  *
	  *
	  */
	function nodeEditLink($subject, $predicate, $object = '') {

		return $GLOBALS['_POWL']['uriBase'].'modules/rdf/node.php?model='.urlencode($GLOBALS['model']->modelURI).
				'&subj='.urlencode(is_a($subject,'resource')?$subject->getLocalName():$subject).
				'&pred='.urlencode(is_a($predicate,'resource')?$predicate->getLocalName():$predicate).
				'&obj[value]='.urlencode(is_a($object,'node')?$object->getLabel():$object).
				(is_a($object,'literal')?'&obj[type]=literal&obj[lang]='.urlencode($object->getLanguage()).
				'&obj[dtype]='.urlencode($object->getDatatype()):'');
	}

	/**
	  * Shortens a string by splitting it in the middle and returning
	  * beginning and end joined by an ellipse (&helip;).
	  *
	  * The total length of the returned string does not exceed $maxLength.
	  *
	  * @param $label the string to be shortened
	  * @param $maxLength the maximum number of chars the returned string may contain
	  * @return a string that constists of the beginning and end of $label but less than $maxLength in length
	  */
	function shorten($label, $maxLength) {

		if($maxLength == 0 || strlen($label) < $maxLength)
			return $label;
		else {
			$offset = floor($maxLength/2);
			return rtrim(substr($label, 0, $offset), '.').'&hellip;'.ltrim(substr($label, -$offset, $offset), '.');
		}
	}

	/**
	  * Highlights text.
	  *
	  * @param $text the text selection to be highlighted.
	  * @return a &lt;span&gt;-tag of class 'searchHighlight' containing the text to be highlighted.
	  */
	function highlightText($text) {

		$highlightRx = '/('.str_replace(' ', ')|(', preg_quote(preg_replace('/[+-><()~*:""&|]/', '', $_REQUEST['search']))).')/i';

		if (strlen($text) > 200) {
			$s = preg_split($highlightRx, $text, -1, PREG_SPLIT_DELIM_CAPTURE);
			foreach($s as $t) {
				if(++$i % 2 == 0)
					$ret .= '<span class="searchHighlight">'.$t.'</span>';
				else
					if (strlen($t) > 100)
						$ret.=substr($t, 0, 50).' ... '.substr($t, -50, 50);
					else
						$ret .= $t;
			}
			return $ret;
		} else
			return preg_replace($highlightRx, '<span class="searchHighlight">\1</span>', $text);
	}

	/**
	  * Renders an instance as shown on the properties page
	  *
	  * @param $instance The instance to be rendered.
	  * @param $allowEdit
	  * @param $maxValueLength
	  * @return A string that can be sent to a web browser for rendering an instance.
	  */
	function renderInstance($instance, $allowEdit = true, $maxValueLength = 0) {
		if (!is_a($instance, 'RDFSResource'))
			$instance = $GLOBALS['model']->resourceF($instance);
		if (isset($_REQUEST['owt'])) {
			$template = $GLOBALS['_OWIKI']['templates'][is_a($instance,'RDFSInstance') ?
				'instance' :
				'class'][$_REQUEST['owt']];
			$owt = $template['file'] ?
				file_get_contents($template['file']) :
				$template['template'];
			return ontowiki::renderInstanceOWT($instance, $owt);
		}

		$ret='<table class="instance" id="instanceEdit"><tbody>';

		foreach ($instance->model->findPredicates($instance, NULL) as $p)
			if ($p->getLocalName() != 'rdf:type') {
				$ret.='<tr><td class="property" valign="top">'.
				        '<a href="'.ontowiki::getURL($p).'">'.ontowiki::getTitle($p).'</a></td><td>';
				$pvs = $instance->model->findStatements($instance, $p, NULL, 0, 10, &$erg);

				$ret.=$erg > 1 ? '<ul>' : '';
				foreach($pvs as $s)
					$ret.=($erg > 1 ? '<li>' : '').
							ontowiki::displayObject($s, $allowEdit, $maxValueLength).
							($erg > 1 ? '</li>' : '');

				$ret.=$erg > 1 ? '</ul>' : '';

				if ($erg > 10)
					$ret.='<a href="statements.php?instance='.urlencode($instance->getLocalName()).
							'&property='.urlencode($p->getLocalName()).'">Show all '.$erg.' &gt;&gt;</a>';
				if ($allowEdit)
					$ret.='<img name="edit" style="display:none" '.
					        'onclick="ow.AjaxRequest(this.parentNode,\'editInstance\',\''.
						    $instance->getLocalName().'\',\''.$p->getLocalName().'\');" '.
						    'src="'.$GLOBALS['_POWL']['uriBase'].'images/edit.gif" />';

				// $ret.='<img name="edit" style="display:none" '.
				//         'onclick="alert()" src="'.$GLOBALS['_POWL']['uriBase'].'images/edit.gif" />';

				$ret.='<a title="Add '.ontowiki::getTitle($p, false).
				      '" href="javascript:powl.winopen(\''.$GLOBALS['_POWL']['uriBase'].
					  'modules/rdf/node.php?model='.urlencode(urlencode($instance->model->modelURI)).
					  '&subj='.urlencode(urlencode($instance->getLabel())).
					  '&pred='.urlencode(urlencode($p->getLabel())).
					  '\',\'comment_edit\',\'width=350,height=400\');" '.
					  'class="edit" name="edit" style="display:none;">'.
					  ($erg == 1 || $erg > 10 ? '<br />' : '').
					  '<img src="'.$GLOBALS['_POWL']['uriBase'].'images/tree/plus.gif" /></a>';

			$ret.='</td></tr>';
		}

		// $ret.='<tr><td>'.timer().ontowiki::resourceComment($instance).
		// 	  '&nbsp;<a title="Add property" href="javascript:powl.winopen(\''.$GLOBALS['_POWL']['uriBase'].
		// 	  'modules/rdf/stm_edit.php?model='.urlencode(urlencode($instance->model->modelURI)).
		// 	  '&subj='.urlencode(urlencode($instance->getLabel())).
		// 	  '\',\'comment_edit\',\'width=350,height=400\');" class="edit" name="edit" style="display:none;">'.
		// 	  '<img src="'.$GLOBALS['_POWL']['uriBase'].'images/tree/plus.gif" /></a>'.
		// 	  '</td></tr>';

		$ret.='</tbody></table>'.ontowiki::resourceComment($instance);
		return $ret;
	}

	/**
	  *
	  *
	  *
	  */
	function resourceComment($resource) {
		if($s=$resource->model->findStatement($resource,'rdf:type',NULL))
			if($r=$resource->model->findStatement('reified://'.$s->dbId,'rdfs:comment',NULL))
				$ret.='<a href="discussion.php?model='.urlencode($s->subj->model->modelURI).'&instance='.urlencode($s->subj->getLocalName()).'&predicate='.urlencode($s->pred->getLocalName()).'" title="'.$r->obj->getLabel().'"><img src="images/comment.png" /></a>&nbsp;';
		$ret.='<a href="javascript:powl.winopen(\''.urlencode(ontowiki::nodeEditLink('reified://'.$s->dbId,'rdfs:comment')).'\',\'comment_edit\',\'width=350,height=400\');" title="Add comment" class="comment" name="comment" style="display:none"><img src="images/comment-add.png" /></a>';
		return $ret;
	}
	function getAvailableTemplates($res) {
		$ret=array();
		if(is_a($res,'RDFSClass')) {
			$tc=$GLOBALS['_OWIKI']['templates']['class'];
			$class=$res;
		} else if(is_a($res,'RDFSInstance')) {
			$tc=$GLOBALS['_OWIKI']['templates']['instance'];
			$class=$res->getClass();
		}
		if($tc)
		foreach($tc as $template)
			if($class->getLocalName()==$template['type'] || $class->isSuperClassRecursive($template['type']))
				$ret[]=$template;
		return $ret;
	}

	/**
	 * <xmp>
	 * @{class} {
	 * 	title = "{swrc:title}",
	 * 	<owt:template property="swrc:author" min="" max="" prefix='author="' suffix='"' infix=" and ">{swrc:name}</owt:template>,
	 * 	booktitle = "{swrc:booktitle}",
	 * 	volume = "{swrc:volume}",
	 * 	pages = "{swrc:pages}",
	 * 	year = "{swrc:year}"
	 * }
	 * </xmp>
	 *
	 * @param $instance
	 * @param $owt
	 * @return
	 **/
	function renderInstanceOWT($instance, $owt) {
		foreach (ontowiki::extractOWTElements($owt) as $element) {
			$rep = '';

				$subj = $element['element'] == 'subject' ?
					array($instance) :
					($element['attributes']['subject'] ?
						explode(',', $element['attributes']['subject']) :
						array(NULL));

				$pred = $element['element'] == 'predicate' ?
					array($instance) :
					($element['attributes']['predicate'] ?
						explode(',', $element['attributes']['predicate']) :
						array(NULL));

				$obj = $element['element'] == 'object' ?
					array($instance) :
					($element['attributes']['object'] ?
						explode(',', $element['attributes']['object']) :
						array(NULL));

				$c = 0;

			foreach ($subj as $subject)
				foreach($pred as $predicate)
					foreach($obj as $object)
						foreach($instance->model->findStatements($subject, $predicate, $object) as $stm) {
							$i = is_null($subject) ? $stm->subj : (is_null($predicate) ? $stm->pred : $stm->obj);
							$s = pwlApplyTemplate($stm->subj, $element['substitution'], 's->');
							$s = pwlApplyTemplate($stm->pred, $s, 'p->');
							$s = pwlApplyTemplate($stm->obj, $s, 'o->');
							$s = str_replace('{:value}', $i->getLabel(), $s);
							$rep .= ($c > 0 ? $element['attributes']['infix'] : '').ontowiki::renderInstanceOWT($i, $s);

							if (++$c == $element['attributes']['max'])
								break;
						}

						$owt = str_replace($element['code'],
							str_replace('&gt;', '>', $element['attributes']['prefix']).$rep.
							str_replace('&gt;', '>', $element['attributes']['suffix']),
							$owt);
		}

		return pwlApplyTemplate($instance, $owt);
	}

	/**
	  * Extracts cx element from page source.
	  * extrahiert cx-Elemente aus dem Seitenquelltext
	  *
	  * cxExtractContxElements extrahiert aus einem contx-Quelltext die
	  * <contx>-Elemente und gibt ein Array mit den betreffenden Parametern
	  * zurck. Jedes Element des Arrays ist wieder ein Array mit folgenden Elementen:
	  * "code" => die komplette Quell-Passage von <contx ...> bis </contx>
	  * "attributes" => Array aller Attribute wobei mit "attribut-name" => Wert
	  * "substitution" => enthlt zunchst den kompletten Inhalt des Elements, wird
	  *                   whrend der Verarbeitung durch den Text ersetzt, der an
	  *                   der betreffenden Stelle einzusetzen ist.
	  *
	  * @param $pagesource the page source
	  * @return an array of cx elements from the page source
	  */
	function extractOWTElements($pagesource, $prefix = 'owt') {
	$res = array();
    if (preg_match_all("((?Uims)<$prefix:(\\w+)[^>]*(>.*</$prefix:\\1>|/>))", $pagesource, $matches)) {
    	for ($i = 0; $i < count($matches[0]); $i++) {
        	$occurance = $matches[0][$i];
        	$attributes = array();
        	$element = "";
        	$substitution = "";

        	if (preg_match("((?Uims)<$prefix:(\\w+)[^>]*>(.*)</$prefix:\\1\\s*>)", $occurance, $subst))
				$substitution = $subst[2];

			if (preg_match("((?Uims)<$prefix:(\\w+)(\\s.*)?/?>)", $occurance, $contxTag)) {
				$element = $contxTag[1];
			if (preg_match_all("((?imsU)\\s+(.*)\\s*=\\s*(['\"])(.*)\\2)", $contxTag[0], $atts))
				for ($k = 0; $k < count($atts[0]); $k++) {
					$attributes[$atts[1][$k]] = $atts[3][$k];
			}
        }

        $entry = array("code" => $occurance,
                       "element" => $element,
                       "attributes" => $attributes,
                       "substitution" => $substitution );
        $res[] = $entry;
      }
    }
    return $res;
  }

	/**
	  * Lists comments loaded from statements table.
	  *
	  * @param $subject
	  * @param $predicate
	  * @param $start
	  * @param $count
	  * @param $erg
	  * @return
	  */
	function listComments($subject = '', $predicate = '', $start = 0, $count = 10, $erg = 0) {
		$ret = array();
		$sql = 'SELECT * FROM statements s
				INNER JOIN log_statements ls USING(subject,predicate,object,l_language,l_datatype,subject_is,object_is)
				INNER JOIN log_actions la ON(ls.action_id=la.id AND la.model_id=s.modelID)'.
                ($subject || $predicate ?
					'INNER JOIN statements ss ON(1 '.
					($subject ?
						'AND ss.subject=\''.$GLOBALS['model']->_dbId($subject).'\'' :
						'').
						($predicate ?
							'AND ss.predicate=\''.$GLOBALS['model']->_dbId($predicate).'\'' :
						'').' AND CONCAT(\'reified://\',ss.id)=s.subject)' :
					'').'WHERE 1 '.
					($GLOBALS['model'] ?
					'AND s.modelID IN ('.$GLOBALS['model']->getModelIds().')' :
					'').'AND ls.ar=\'a\' AND s.subject like \'reified://%\' AND s.predicate=\''.
							$GLOBALS['RDFS_comment']->getURI().'\' ORDER BY date DESC';

		$rs = $GLOBALS['powl']->dbConn->PageExecute($sql, $count, $start/$count+1);
		$erg = $rs->_maxRecordCount ? $rs->_maxRecordCount : $rs->_numOfRows;

		if ($rs) foreach($rs->getArray() as $row) {
			$stm = $GLOBALS['model']->_convertRowToStatement(array_slice($GLOBALS['model']->store->dbConn->getRow('
					SELECT * FROM statements WHERE id=\''.str_replace('reified://', '', $row[28]).'\''), 0, 8));

			$stm->reified = $GLOBALS['model']->_convertRowToStatement(array_slice($row, 0, 8));
			$stm->user = $row[15];
			$stm->added = $row[16];
			$ret[] = $stm;
		}
		return $ret;
	}

	/**
	  * Draws the tabs and their border
	  *
	  * @param $tabs
	  * @param $current
	  * TODO: move border css to style sheet
	  */
	function tabs($tabs, $current = 0) {
		echo('<div class="tabs"><div>');
		foreach($tabs as $url=>$label)
			echo('<a href="'.$url.'" '.($current == $i++ ? 'class="current"' : '').'>'.$label.'</a>');
		// TODO: find out why the tab-line div is not closed
		echo('</div></div><div id="tab-line">');
	}

	/**
	  * Draws the tabs if classes are selected to be shown.
	  *
	  * @param $current
	  * @param $class
	  */
	function classtabs($current = 0, $class = NULL) {
		if ($class || $GLOBALS['class']) {
			$class = $class ? $class : $GLOBALS['class'];
		} else {
			$pref = '#';
		}

		if ($_REQUEST['select']) {
			foreach($_REQUEST['select'] as $key=>$val) {
				$select.=$val ? 'select['.$key.']='.urlencode($val) : '';
			}
		}

		$tabs = array(
			$pref.ontowiki::getURL($class, NULL, $select)=>'Instances',
//			$pref.ontowiki::getURL($class,'instance')=>'Properties',
			$pref.ontowiki::getURL($class, 'map', $select)=>'Map',
			$pref.ontowiki::getURL($class, 'calendar')=>'Calendar',
			$pref.ontowiki::getURL($class, 'history')=>'History',
			$pref.ontowiki::getURL($class, 'discussion')=>'Discussion',
			$pref.ontowiki::getURL($class, 'edit')=>'Edit'
		);

		ontowiki::tabs($tabs, $current);
	}

	/**
	  * Draws the tabs if instances are selected to be shown.
	  *
	  * @param $current
	  * @param $class
	  */
	function instancetabs($current = 0, $instance = NULL) {
		if ($instance || $GLOBALS['instance']) {
			$instance = $instance ? $instance : $GLOBALS['instance'];
		} else {
			$pref='#';
		}

		$tabs = array(
			$pref.ontowiki::getURL($instance)=>'Properties',
			$pref.ontowiki::getURL($instance, 'map')=>'Map',
			$pref.ontowiki::getURL($instance, 'calendar')=>'Calendar',
			$pref.ontowiki::getURL($instance, 'history')=>'History',
			$pref.ontowiki::getURL($instance, 'discussion')=>'Discussion',
			$pref.ontowiki::getURL($instance, 'edit')=>'Edit'
		);

		ontowiki::tabs($tabs,$current);
	}

	/**
	  * Returns an img-tag with the current resource's average rating obtained from the data base.
	  *
	  * @param $resource the resource whose rating should to be retrieved.
	  */
	function displayRating($resource) {
		list($avgRating, $numRatings) =
				$GLOBALS['powl']->dbConn->getRow('SELECT AVG(rating),COUNT(*) FROM ratings WHERE modelID="'.
				$resource->model->modelID.'" AND resource="'.$resource->getURI().'" GROUP BY modelID,resource');

		if ($numRatings)
			return '<img src="'.$_OWIKI['uriBase'].'images/stars/ur_star_'.round($avgRating).($avgRating - floor($avgRating) > 0.5 &&
					$avgRating - floor($avgRating) < 0.75 ? 'a' : '').'.png" />&nbsp;('.$numRatings.')';
	}

	/**
	  * Returns a URL for the current instance.
	  *
	  * @param $instance the currently selected instance.
	  * @param $view
	  * @param $queryString
	  */
	function getURL($instance, $view = NULL, $queryString = NULL) {
		if ($view == 'edit') {
			$view = NULL;
			$queryString = ($queryString ? $queryString.'&' : '').'action=edit';
		}

		if ($view) {
			$queryString = 'view='.$view.($queryString ? '&'.$queryString : '');
		}

		if ($instance->model->modelURI != $GLOBALS['model']->modelURI)
//			&& !($instance->getURI()==$instance->model->modelURI.$instance->getLocalName() && stristr($instance->getURI(),$GLOBALS['_OWIKI']['urlBase'].$GLOBALS['_OWIKI']['uriBase'])))
			$queryString = 'model='.urlencode($instance->model->modelURI).($queryString ? '&'.$queryString : '');

		if (!is_a($instance, 'resource'))
			$instance = $GLOBALS['model']->resourceF($instance);

		if ($GLOBALS['_OWIKI']['intuitiveURLs'] &&
				stristr($instance->getURI(), $GLOBALS['_OWIKI']['urlBase'].$GLOBALS['_OWIKI']['uriBase']))
			return $instance->getURI().($queryString ? '?'.$queryString : '');
		else
			return ($view ? $view : 'index').'.php?instance='.
					urlencode($instance->getLocalName()).($queryString ? '&'.$queryString : '');
	}

} // class ontowiki


function deleteStatement($id) {
	$GLOBALS['model']->remove($id);
}

function editInstance($instance,$property) {
	$instance = $GLOBALS['model']->instanceF($instance);
	return editValues($instance->getClass,
					  $property,
					  $instance->listPropertyValues($property),
					  'inst['.$instance->getLocalName().']');
}

function editValues($class, $property, $value='', $formElemPrefix = 'prop') {
	$p = $GLOBALS['model']->propertyF($property);

	if ($p->isObjectProperty())
		return editResource::edit($formElemPrefix.'['.$property.']', $value);
	elseif ($widget = pwlGetWidget($GLOBALS['model']->getClass($class),
								   $GLOBALS['model']->propertyF($property),
								   $value,
								   array('readonly'=>false,
								   'name'=>$formElemPrefix.'['.$property.']',
								   'AttributeStyle'=>'width:250px'))) {
		return $widget;
	}
	else
		return editnode::edit($formElemPrefix.'['.$property.']', $value);
}

if(!$model) {
	if(dirname($_SERVER['REQUEST_URI'])!='\\' && $model=$powl->getModel($_OWIKI['urlBase'].dirname($_SERVER['REQUEST_URI'])))
		$_SESSION['_ETS']['model']=$model->modelURI;
}

if($model) {
	if($_REQUEST['class'])
		$class=$model->classF($_REQUEST['class']);
	else if(!$_REQUEST['instance'] && $_SERVER['REQUEST_URI']!=$_SERVER['SCRIPT_NAME'].($_SERVER['QUERY_STRING']?'?'.$_SERVER['QUERY_STRING']:''))
		$_REQUEST['instance']=$_OWIKI['urlBase'].$_SERVER['REDIRECT_URL'];
	if($_REQUEST['instance']) {
		$instance=$model->instanceF($_REQUEST['instance']);
		$powl->dbConn->Execute('INSERT popularity (modelID,uri) VALUES ('.$model->modelID.',"'.$instance->getURI().'")');
		if(!$class)
			$class=$instance->getClass();
	}
}
#$model->renameNamespace('http://localhost/conferences/','http://localhost/ontowiki/conferences/');
?>