USE `powl`;

CREATE TABLE `models` (
  `modelID` bigint(20) NOT NULL default '0',
  `modelURI` varchar(255) NOT NULL default '',
  `baseURI` varchar(255) default '',
  PRIMARY KEY  (`modelID`),
  UNIQUE KEY `m_modURI_idx` (`modelURI`)
);
CREATE TABLE `namespaces` (
  `modelID` bigint(20) NOT NULL default '0',
  `namespace` varchar(255) NOT NULL default '',
  `prefix` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`modelID`,`namespace`),
  KEY `n_mod_idx` (`modelID`)
);
CREATE TABLE `statements` (
  `modelID` bigint(20) NOT NULL default '0',
  `subject` varchar(255) NOT NULL default '',
  `predicate` varchar(255) NOT NULL default '',
  `object` text,
  `l_language` varchar(255) default '',
  `l_datatype` varchar(255) default '',
  `subject_is` char(1) NOT NULL default '',
  `object_is` char(1) NOT NULL default '',
  `id` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY `s_id_idx` (`id`),
  KEY `s_mod_idx` (`modelID`),
  KEY `s_sub_pred_idx` (`subject`(200)),
  KEY `s_pred_idx` (`predicate`(200)),
  KEY `s_obj_idx` (`object`(250))
);