<?php
/*
 * include.php
 * Encoding: ISO-8859-1
 *
 * Copyright (c) 2006 Sren Auer <soeren@auer.cx>
 *
 * This file is part of pOWL - web based ontology editor.
 *
 * pOWL is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * pOWL is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with pOWL; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

/**
 * Script which is included everywhere in POWL and ensures availability
 * of RDFAPI, RDFSAPI and other common functions and classes.
 *
 * @package powl
 * @author Sren Auer <soeren@auer.cx>
 * @copyright Copyright (c) 2004
 * @version $Id: include.php,v 1.117 2006/11/03 14:44:31 soerenauer Exp $
 */

error_reporting(E_ALL & ~E_NOTICE);
ini_set('max_execution_time','6000');
ini_set('allow_call_time_pass_reference','1');

// remove magic quotes
function magicQuotesRemove(&$array) {
   if(!get_magic_quotes_gpc())
       return;
   foreach($array as $key => $elem) {
       if(is_array($elem))
           magicQuotesRemove($array[$key]);
       else
           $array[$key] = stripslashes($elem);
   }
}
magicQuotesRemove($_GET);
magicQuotesRemove($_POST);
magicQuotesRemove($_REQUEST);
magicQuotesRemove($_COOKIE);

// capture important path information
foreach(get_included_files() as $file)
	if(ereg('[/\]include.php$',$file))
		$_POWL['installPath']=str_replace('\\','/',ereg_replace('[/\]include.php$','/',$file));

// load database connection information
if(!is_readable($_POWL['installPath'].'config.inc.php'))
	die('<b>pOWL error:</b> Configuration file "'.$_POWL['installPath'].'config.inc.php" not found. Please copy "config.inc.php-dist" to "config.inc.php" and adjust it according to your needs!');
include($_POWL['installPath'].'config.inc.php');

// start session
@session_start();
if(empty($_POWL['db']['type'])) {
	$store=empty($_SESSION['store'])?$_REQUEST['store']:$_SESSION['store'];
	if(count($_POWL['db'])>1 && !empty($_POWL['db'][$store]))
		$_POWL['db']=$_POWL['db'][$store];
	else
		$_POWL['db']=array_shift($_POWL['db']);
}

// load classes and functions common to all POWL modules
@define('POWLAPI_INCLUDE_DIR', $_POWL['installPath']."powlapi/");
include_once(POWLAPI_INCLUDE_DIR.'include.php');

// if not logged in redirect to login page
if(!isset($_POWL['deactivateLogin'])) {
	if(!isset($_SESSION['PWL']['user']) && !strstr($_SERVER['PHP_SELF'],$_POWL['uriBase'].'index.php') && strstr($_SERVER['PHP_SELF'],$_POWL['uriBase']))
		header('Location: '.$_POWL['uriBase'].'?target='.urlencode($_SERVER['REQUEST_URI']));
} else
	$_SESSION['PWL']['user']=$_SERVER['REMOTE_ADDR'];

// include cms api
include_once($_POWL['installPath'].'modules/cms/api/include.php');

// for debugging purposes
if($_POWL['debug'])
	require_once(RDFAPI_INCLUDE_DIR.'util/adodb/adodb-errorhandler.inc.php');

// connect to store
ob_start();
$_ET['store']=$powl=new POWLStore($_POWL['db']['type'],$_POWL['db']['host'],$_POWL['db']['db'],$_POWL['db']['user'],$_POWL['db']['pass'],$_POWL['SysOntModelURI']);
#$_ET['store']->dbConn->LogSQL(); // incompatible with $_POWL['db']['tablePrefix'] !!!
#$_ET['store']->dbConn->debug=true;

// initialise active model
if(!empty($_REQUEST['model']))
	$_SESSION['_ETS']['model']=$_REQUEST['model'];
if(!empty($_SESSION['_ETS']['model']))
	$_ET['rdfsmodel']=$powl->getModel($_SESSION['_ETS']['model']);
ob_end_clean();

// load additional modules
if($modules=pwlGetSysOntClassInstances('Module'))
	foreach($modules as $module)
		if(file_exists($_POWL['installPath'].'modules/'.strtolower($module->getLocalName()).'/include.php'))
			include_once($_POWL['installPath'].'modules/'.strtolower($module->getLocalName()).'/include.php');

// load model specific sysont
if(!empty($GLOBALS['_POWL']['SysOnt']) && $modelClass=$GLOBALS['_POWL']['SysOnt']->getClass('Model'))
	if($inst=$modelClass->findInstance(array('modelURI'=>$_ET['rdfsmodel']->modelURI)))
		if($sysont=$inst->getPropertyValuePlain('modelSysOntURI'))
			$_POWL['SysOnt']=$powl->getModel($sysont);
?>