<?php
/*
 * modules/models/index.php
 * Encoding: ISO-8859-1
 *
 * Copyright (c) 2006 Sren Auer <soeren@auer.cx>
 *
 * This file is part of pOWL - web based ontology editor.
 *
 * pOWL is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * pOWL is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with pOWL; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

/**
 * RDFS-model selector and creator.
 *
 * @package powl
 * @author Sren Auer <soeren@auer.cx>
 * @copyright Copyright (c) 2004
 * @version $Id: index.php,v 1.75 2006/11/07 12:33:50 p_frischmuth Exp $
 */

include('../../include.php');
pwlHTMLHeader();

switch(!empty($_REQUEST['aktion'])?$_REQUEST['aktion']:(!empty($_REQUEST['action'])?$_REQUEST['action']:'')) {
	// create a new database with the name in config.inc.php
	case 'createdb':
#		$_ET['store']->dbConn->LogSQL(false);
		$db=ADONewConnection($_POWL['db']['type']);
		if($db->Connect($_POWL['db']['host'],$_POWL['db']['user'],$_POWL['db']['pass']))
			$db->Execute('CREATE DATABASE `'.$_POWL['db']['db'].'`');
			echo('<script language="javascript">document.location.href="'.
				$_SERVER["PHP_SELF"].'?action=createtables"</script>');
			exit;
	// create all needed tables in the empty database
	case 'createtables':
		if (!$powl->isSetup($_POWL[db][type])) {
			$_ET['store']->createTables($_POWL['db']['type']);
#			$_ET['store']->dbConn->LogSQL();
		}
		break; // do not create the SysOnt automatically
	// create system ontology (both ontology from SysOnt.owl and user system ontology
	case 'createsysont':
		if(!$_ET['store']->modelExists($_POWL['SysOntSchemaURI'])) {
			$m=$_ET['store']->getNewModel($_POWL['SysOntSchemaURI']);
			$m->dontCheckForDuplicatesOnAdd=true;
			$_ET['store']->dbConn->StartTrans();
			#ob_start(); // prevent RAP warnings
			$m->load($_POWL['installPath'].'SysOnt.owl',NULL,true);
			$_ET['store']->dbConn->CompleteTrans();
			#ob_end_clean();
		}
		if(empty($_POWL['SysOnt']->modelID)) {
			$m=$_ET['store']->getNewModel($_POWL['SysOntModelURI']);
			$m->setImports($_POWL['SysOntSchemaURI']);
			$m->setBaseURI($_POWL['SysOntSchemaURI']);
			$m->asResource->setComment('This is the local pOWL system ontology. It contains instances of the classes defined in the system ontology schema.');
			$powl->SysOnt=$GLOBALS['_POWL']['SysOnt']=$powl->getModel($_POWL['SysOntModelURI']);
			echo('<script language="javascript">top.frames[\'docu\'].location.reload();</script>');
			$_ET['store']->dbConn->_errorMsg='';
		}
		echo('<script language="javascript">top.frames[\'top\'].location.reload(true);</script>');
		break;
	case 'select':
		$_SESSION['_ETS']['model']=$_REQUEST['model'];
		#pwlSessionVar('model');
		echo('<script language="javascript">top.frames[\'top\'].document.forms[\'models\'].elements[\'model\'].value="'.$_REQUEST['model'].'";</script>');
		break;
	case 'delete':
		if($_REQUEST['selected'])
			foreach($_REQUEST['selected'] as $del) {
				if(!$powl->aclCheck('Edit',$del))
					echo('Not allowed to delete "'.$del.'"!');
				else {
					$_ET['store']->deleteModel($del);
					if($del==$_SESSION['_ETS']['model'])
						unset($_SESSION['_ETS']['model'],$_ET['rdfsmodel']);
				}
		}
		echo('<script language="javascript">powl.reloadGET(top.frames[\'top\']);</script>');
		break;
}

// check whether database exists
if (!$powl->isDatabaseCreated($_POWL[db][type], $_POWL[db][db]))  {
	echo 'Database \''.$_POWL[db][db].'\' not found.'.
		' -  <a href="?action=createdb">Create Database and DB Structure</a>';
} 
// check whether database is initialzed with the right tables
else if (!$powl->isSetup($_POWL[db][type])) {
	echo 'Database seems to be uninitialized.'.
		' - <a href="?action=createtables">Create DB Structure</a>';
} else {
?>
<h2>Select existing model:</h2>
<?php
	// check whether the system ontology exists
	if ($_POWL['db']['backend']!='protege' && (empty($_POWL['SysOnt']->modelID) || 
			!$_ET['store']->modelExists('http://powl.sf.net/SysOnt/0.1#'))) {
				echo '<p> System ontology for user/group administration and 
					settings seems to be absent - <a href="?action=createsysont">
					Create system ontology</a></p>';
			}
	
	$list = $powl->listModels();
	
	// show the models stored in the database
	echo '<form method="post" name="delform" action="'.$_SERVER['PHP_SELF'].
		'"><table><tr><th><a href="javascript:powl.toggleChecked(document.forms[\'delform\'],\'selected\');">S</a></th><th>'.
		pwl_('Model').'</th><th>'.pwl_('Comment').'</th><th>'.pwl_('Type').'</th>';
	
	if (!empty($_REQUEST['statistics'])) {
		echo('<th>'.pwl_('Classes').'</th><th>'.pwl_('Properties').'</th><th>'.
			pwl_('Instances').'</th><th>'.pwl_('Triples').'</th>');
	}
		
	echo('<th>'.pwl_('Action').'</th></tr>');
	
	$i=0;
	if (!$list)	echo('<tr><td colspan="6">No models found!</td></tr>');
	else foreach ($list as $uri=>$m) {
		echo '<tr'.($i++%2==0?' class="even"':'').'>
	        <td><input type="checkbox" name="selected[]" value="'.$uri.'"></td>
			<td><a href="?action=select&model='.urlencode($uri).'" title="Select">'.
			(!empty($_SESSION['_ETS']['model'])&&$uri==$_SESSION['_ETS']['model']?"<b>$uri</b>":$uri).
			'</a></td><td width="300">';
		
		if ($comment=parray_shift($m->asResource->listComments())) {
#			foreach($m->asResource->listComments() as $comment)
			echo '<div title="'.$comment->getLabel().'">'.substr($comment->getLabel(),0,200).
				(strlen($comment->getLabel())>200?pwlEditNodeLink($m->asResource,$GLOBALS['RDFS_comment'],$comment,'...'):'').
				'</div>';
		}
		
		echo "<td>".$m->type."</td>";
		
		if (!empty($_REQUEST['statistics'])) {
			echo '<td>'.$m->countClasses(false).($m->importsIds?'&nbsp;('.
				$m->countClasses().')':'').'</td>'.'<td>'.$m->countProperties(false).
				($m->importsIds?'&nbsp;('.$m->countProperties().')':'').'</td>'.
				'<td>'.$m->countInstances(false).($m->importsIds?'&nbsp;('.
				$m->countInstances().')':'').'</td>'.'<td>'.$m->countTriples(false).
				($m->importsIds?'&nbsp;('.$m->countTriples().')':'').'</td>';
		}
				
		echo '<td nowrap="nowrap"><a href="?action=select&model='.urlencode($uri).
			'" title="Select">[S]</a>&nbsp;<a href="#" onclick="powl.winopen(\'model_edit.php?model='.
			urlencode($uri)."','model_edit','width=350,height=600');\" title=\"Edit\">
			<img src=\"../../images/edit.gif\"></a>&nbsp;".($powl->aclCheck('Edit',$m)?"
			<a onclick=\"return confirm('".pwl_('Do you really want to delete this object?').
			"')\" href=\"?action=delete&selected[]=".urlencode($uri).
			'" title="Delete"><img src="../../images/delete.gif"></a>':'').'</td></tr>';
	}
?>
<tr>
<th colspan="9" align="left"><img src="../../images/item_ltr.png">&nbsp;
	<select onchange="with(this.form) { if(aktion.value=='delete') { if(!confirm('<?php echo pwl_('Do you really want to delete this object?'); ?>')) return; } else action=aktion.value; submit(); }" name="aktion" style="font-size:9px; font-weight:bold; background-color:#d3dce3;">
		<option value=""><?php echo pwl_('Selected:'); ?></option>
		<option value="delete"><?php echo pwl_('Delete'); ?></option>
		<option value="compare.php"><?php echo pwl_('Compare'); ?></option>
		<option value="merge.php"><?php echo pwl_('Merge'); ?></option>
	</select>
	<?php if($powl->aclCheck('AddModels')) { ?>
		&nbsp;&nbsp;&nbsp;<img src="../../images/item_ltr.png" align="absmiddle">&nbsp;<a href="#" onclick="powl.winopen('model_add.php','model_add','width=350,height=480');"><?php echo pwl_("Create/import new model"); ?></a>
		&nbsp;&nbsp;&nbsp;<img src="../../images/item_ltr.png" align="absmiddle">&nbsp;<a href="#" <?php echo ini_get('allow_url_fopen')?'onclick="powl.winopen(\'import.php\',\'import\',\'width=500,height=600\');">':'class="deactivated" title="'.pwl_('Feature deactivated:').' '.pwl_('The PHP installation on this server does not support \'url_fopen\'.').')">'; echo pwl_("Select a model to import"); ?></a>
	<?php } ?>
</th>
</tr>
</table>
</form>
<form>
<input type="checkbox" name="statistics"/ onclick="this.form.submit()" <?php echo !empty($_REQUEST['statistics'])?' checked':''; ?>> <?php echo pwl_('Show model statistics'); ?>
</form>
	
<?php 
	if ($_ET['rdfsmodel']) { 
?>
		<p><?php echo pwl_("Selected model"); ?>:</p>
		<ul><li><?php echo pwl_('Edit:'); ?>
<?php 
		if(method_exists($_ET['rdfsmodel'],'listalldifferentsets')) { 
?>
			<a href="javascript:void(powl.winopen('alldifferent.php','alldifferent','width=600,height=600'))"><?php echo pwl_("owl:AllDifferent sets"); ?></a> |
<?php
		} 
?>
		<a href="javascript:void(powl.winopen('privileges.php','privileges','width=600,height=600'))"><?php echo pwl_("privileges"); ?></a>
		</li>
		<li><a href="javascript:void(powl.winopen('validate.php','validate','width=830,height=600'))"><?php echo pwl_("Online validation"); ?></a></li>
		<li><?php echo pwl_('Export:'); ?> <a href="javascript:void(powl.winopen('export.php','export','width=600,height=600'))"><?php echo pwl_("Source"); ?></a> |
		<a href="export_html.php" target="_blank"><?= pwl_("HTML") ?></a></li>
		</ul>
<?php
	}
}
pwlHTMLFooter();
?>