/*
 * CSVStatementHandler.java
 * Encoding: ISO-8859-1
 *
 * Copyright (c) 2006 Philipp Frischmuth <philipp@frischmuth24.de>
 *
 * This file is part of pOWL - web based ontology editor.
 *
 * pOWL is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * pOWL is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with pOWL; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package net.sf.powl;

import org.openrdf.rio.StatementHandler;

/**
 * This interface extends the StatementHandler interface and adds a method,
 * which writes the data to the files.
 * 
 * @author Philipp Frischmuth
 * @version 0.1, 2006-10-25
 */
public interface CSVStatementHandler extends StatementHandler {

	/**
	 * This method writes the collected data into the csv files.
	 */
	public void writeDataToFiles();
}
